// Config.cpp : implementation file
//

#include "stdafx.h"
#include "tulsa sample app.h"
#include "Config.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

	// Disk buffering options
char BufferOptionListDesc[][30] =  {
	" 4 x 524K", " 8 x 262K", "16 x 131K"};

int BufferOptionListCount[] = {4, 8, 16};
int	BufferOptionListSize[] =  {524288,  262144,  131072};
								
	
#define NUM_BUFFER_OPTIONS_8	3		

/////////////////////////////////////////////////////////////////////////////
// CConfig dialog


CConfig::CConfig(CWnd* pParent /*=NULL*/)
	: CDialog(CConfig::IDD, pParent)
{
	//{{AFX_DATA_INIT(CConfig)
	m_AVSync = FALSE;
	m_GenLock = FALSE;
	//}}AFX_DATA_INIT
}


void CConfig::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConfig)
	DDX_Control(pDX, IDC_BUFFER_OPTIONS, m_BufferOptionList);
	DDX_Check(pDX, IDC_AVSYNC, m_AVSync);
	DDX_Check(pDX, IDC_GENLOCK, m_GenLock);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CConfig, CDialog)
	//{{AFX_MSG_MAP(CConfig)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConfig message handlers

BOOL CConfig::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	int VideoModeID;
	if (m_VideoMode == VIDEO_MODE_PAL) {
		VideoModeID = IDC_PALIB;
	} else {
		VideoModeID = IDC_NTSC;
	}
	CheckRadioButton(IDC_NTSC, IDC_PALIB, VideoModeID);

	CWnd* pwnd = GetDlgItem(IDC_GENLOCK);

    if (pwnd){ 
        pwnd->EnableWindow(m_GenLockSupport);
    }

	m_NumBufferOptions = NUM_BUFFER_OPTIONS_8;		

	int select = -1;
	for (int i = 0; i < m_NumBufferOptions; i++) {
		m_BufferOptionList.AddString(BufferOptionListDesc[i]);
		if (m_DiskBufferCount == BufferOptionListCount[i] &&
			m_DiskBufferSize == BufferOptionListSize[i]) {
			select = i;
		}
	}

	if (select == -1) {			// The current setting does not match one
		select = 0;				//  in the list, use the first option
	}
	m_BufferOptionList.SetCurSel(select);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CConfig::OnClose() 
{
	CDialog::OnClose();
}

void CConfig::OnOK() 
{
	int VideoModeID = GetCheckedRadioButton(IDC_NTSC, IDC_PALIB);
	if (VideoModeID == IDC_PALIB) {
		m_VideoMode = VIDEO_MODE_PAL;
	} else {
		m_VideoMode = VIDEO_MODE_NTSC;
	}

	int selected = m_BufferOptionList.GetCurSel();
	m_DiskBufferCount = BufferOptionListCount[selected];
	m_DiskBufferSize = BufferOptionListSize[selected];

	CDialog::OnOK();
}
